<script lang="ts">
import Vue from 'vue';
import GroupButtons from '~/components/common/group-buttons.vue';

export default Vue.extend({
  components: {
    GroupButtons,
  },
  props: {
    data: {
      required: true,
      type: Object,
    },
    sensitivity: {
      type: Number,
      required: false,
      default: 0.25,
    },
  },
  data() {
    return {
      currentLinkIndex: 0,
      open: false,
      isVisible: false,
      isMobile: false,
      sticky: false,
      offset: 0,
    };
  },

  mounted() {
    document.addEventListener('click', this.closeDropdown);
    window.addEventListener('resize', this.detectMobile);
    this.detectMobile();
    if (this.isMobile) {
      document.addEventListener('scroll', this.checkSticky);
    }

    window.addEventListener('load', () => {
      const parent = document.getElementById('top-nav-parent');
      const children = Array.from(parent?.children);
      const [categoriesContainer] = children.splice(0, 2);
      const childrenObserver = new IntersectionObserver(
        (entries) => {
          entries.forEach((entry) => {
            if (entry.isIntersecting) {
              this.currentLinkIndex = children.findIndex(
                (item) => item === entry.target,
              );
            }
          });
        },
        {
          rootMargin: '0px',
          threshold: this.isMobile ? 0.1 : this.sensitivity,
        },
      );

      const categoriesObserver = new IntersectionObserver(
        (entries) => {
          this.isVisible = !entries.some((entry) => entry.isIntersecting);
        },
        {
          rootMargin: '0px',
          threshold: 0.1,
        },
      );
      categoriesObserver.observe(categoriesContainer);
      children.forEach((section) => childrenObserver.observe(section));
    });
  },
  beforeDestroy() {
    document.removeEventListener('click', this.closeDropdown);
    window.removeEventListener('resize', this.detectMobile);
  },
  methods: {
    closeDropdown() {
      this.open = false;
    },
    toggleDropdown() {
      this.open = !this.open;
    },
    detectMobile() {
      this.isMobile = window.innerWidth < 1025;
    },
    checkSticky() {
      const fixedDistance = 125;
      const currentDistance = this.$refs.dropdown.getBoundingClientRect().top;
      this.offset =
        currentDistance > this.offset ? currentDistance : this.offset;
      this.sticky =
        currentDistance <= fixedDistance &&
        window.scrollY > this.offset - fixedDistance;
    },
  },
});
</script>

<template>
  <div id="top-nav-parent">
    <GroupButtons class="categories" :data="data" />
    <div
      id="top-navigation"
      class="top-navigation"
      :class="{ flex: isVisible }"
    >
      <div
        id="navigation-dropdown"
        ref="dropdown"
        class="dropdown"
        :class="{
          open,
          visible: isVisible,
          mobile: isMobile,
          sticky: sticky,
        }"
        @click.stop="toggleDropdown"
      >
        <div class="control">
          <SlpTypography variant="body2-bold" class="control-text">
            <SlpIcon
              v-if="data.buttons[currentLinkIndex].icon_left"
              :name="data.buttons[currentLinkIndex].icon_left"
              variant="marketing"
              size="md"
              class="icon"
            />
            {{ data.buttons[currentLinkIndex].text }}</SlpTypography
          >
          <SlpIcon
            :name="open ? 'chevron-up' : 'chevron-down'"
            variant="product"
            size="md"
          />
        </div>
        <div class="options" @click.stop="closeDropdown">
          <SlpTypography
            v-for="option in data.buttons"
            :key="option.text"
            :href="option.href"
            variant="body2-bold"
            class="option"
            tag="a"
          >
            <SlpIcon
              v-if="option.icon_left"
              :name="option.icon_left"
              variant="marketing"
              size="md"
              class="icon"
            />{{ option.text }}</SlpTypography
          >
        </div>
      </div>
    </div>
    <slot></slot>
  </div>
</template>

<style lang="scss" scoped>
.categories.group-cta {
  margin: $spacing-96 0;
}

.top-navigation {
  position: relative;
  display: none;
  &.flex {
    width: 100%;
    display: flex;
    justify-content: center;
  }

  @media (max-height: $breakpoint-lg) {
    min-height: 66px;
  }

  .dropdown {
    display: none;
    background: $color-surface-900;
    border: 1px solid $color-surface-950;
    border-radius: 33px;
    padding: $spacing-16;
    position: fixed;
    top: 125px;
    z-index: 3;
    cursor: pointer;
    &.open .options {
      display: block;
    }
    &.visible {
      display: block;
    }
    &.mobile {
      position: absolute;
      top: 0;
      display: block;
    }
    &.sticky.mobile {
      top: 125px;
      position: fixed;
    }
  }
  .control,
  .control-text,
  .option {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    color: $color-text-300;
    white-space: nowrap;

    .icon {
      margin-right: $spacing-8;
    }
  }
  .option {
    margin: $spacing-24 0;
    &:hover {
      text-decoration: underline;
    }
    &:last-child {
      margin-bottom: 0;
    }
  }
  .options {
    display: none;
  }
}
@media (max-width: $breakpoint-lg) {
  .categories {
    margin: $spacing-64 0;
    padding: 0 !important;
    &:deep(.group-cta__container) {
      display: none;
    }
  }
}
</style>
